# CLDS Library

## Rust Library to declare and manage **LibreClouds** [Klouds](https://rlung.librecloud.online/LibreCloud/Klouds#klouds)

Part of the following developments:

- [CloudMandala](https://rlung.librecloud.online/LibreCloud/CloudMandala#cloudmandala)
- [Zteron](https://rlung.librecloud.online/LibreCloud/CloudMandala#cloudmandala)

It includes definitions and functions for the following providers:

- manual
- [UpCloud](https://upcloud.com) resources

It is responsible to run **task/services** defined in **LibreClouds** [Klouds](https://rlung.librecloud.online/LibreCloud/Klouds), implementation differs from one provider to other.

### How to use

1 - Clone or download this lib in a path, better outside of target development

2 - Get current version from <u>Cargo.toml</u>

3 - Include a line like the one below in <u>target development Cargo.toml</u> (adjust version & path) and **use** whatever is need.

```toml
clds = { version = "0.1.0", path = "../lib/clds" }
```

### Structure

<pre>
.
├── Cargo.toml
└── src
    ├── clouds
    │   ├── defs.rs
    │   ├── on_clouds.rs
    │   └── upcloud.rs
    ├── clouds.rs
    ├── cmds.rs
    ├── defs.rs
    ├── lib.rs
    ├── monitor
    │   ├── defs.rs
    │   └── utils.rs
    ├── monitor.rs
    ├── pkgs.rs
    ├── providers
    │   ├── defs
    │   │   ├── manual.rs
    │   │   └── upcloud.rs
    │   ├── defs.rs
    │   ├── manual.rs
    │   └── upcloud.rs
    ├── providers.rs
    ├── tsksrvcs.rs
    └── utils.rs
</pre>

## Author

- [Jesús Pérez](https://info.jesusperez.pro).

## License

MIT
