use anyhow::{anyhow,Result};
use std::{fs}; //,io};
use std::fs::OpenOptions;
use std::path::Path;
use std::io::{Write};
use std::process::{Command};
use std::str;

pub fn write_str_data(output_path: String, data_str: String, msg: String) -> Result<()> {
	if Path::new(&output_path).exists() {
		fs::remove_file(&output_path)?;
	}
	let mut file = OpenOptions::new().write(true).create(true).open(&output_path)?;
	file.write_all(data_str.as_bytes())?;
	if ! msg.is_empty() {
		let now = chrono::Utc::now().timestamp();
		let out = format!("{}: [{}] -> {}\n",&now,&msg,&output_path);
		println!("{}",&out);
	}
	Ok(())
}

pub fn run_command(str_cmd: &str) -> Result<String> {
  let mut args: Vec<&str> = str_cmd.split(" ").collect();
	let cmd = args[0].to_owned();
	args.remove(0);
	// println!("cmd: {}, args: {:?}",&cmd,&args);
	let result = Command::new(&cmd)
	.args(&args)
	.output()?;
 	// dbg!(&result);
	match &result.status.code() {
		Some(code) =>
			if format!("{}",code) == "0" {
				let mut res=String::from(str::from_utf8(&result.stdout).unwrap_or_else(|_| ""));
				if res.ends_with("\n") {
					res.pop();
				}
				res = res.replace("\n"," ").replace("<none>","");
				Ok(res)
		  } else {
				let err = str::from_utf8(&result.stderr).unwrap_or_else(|_| "");
		    Err(anyhow!("Running {}: failed:\n {}",&cmd,&err))
			}
		None => Ok(String::from(""))
	}
}
